﻿using System;

namespace Obserwator
{
    using UMK.WzorceOperacyjne;

    class Program
    {
        private static Modulo om;

        private static void aktualizujModulo(object sender, int wartość)
        {
            if(om != null) om.Aktualizuj(wartość);
        }

        static void Main(string[] args)
        {
            Podmiot podmiot = new Podmiot();
            Dzielenie od = new Dzielenie(3);
            om = new Modulo(3);

            EventHandler<int> aktualizujDzielnie = (object sender, int wartość) => { od.Aktualizuj(wartość); };

            podmiot.ZmianaWartości += aktualizujDzielnie;
            podmiot.ZmianaWartości += aktualizujModulo;

            podmiot.ZmieńWartość(9);
            Console.WriteLine();
            podmiot.ZmieńWartość(10);
            Console.WriteLine();

            podmiot.ZmianaWartości -= aktualizujModulo;

            podmiot.ZmieńWartość(2);
            Console.WriteLine();
        }                    
    }
}
